commit c496f489f02515b8f687dc4effe259180a49a279
Author: Juergen Gross <jgross@suse.com>
Date:   Tue Sep 6 12:51:06 2016 +0200

    libxl: add "xl qemu-monitor-command"
    
    Add a new xl command "qemu-monitor-command" to issue arbitrary commands
    to a domain's device model. Syntax is:
    
    xl qemu-monitor-command <domain> <command>
    
    The command is issued via qmp human-monitor-command command. Any
    information returned by the command is printed to stdout.
    
    Signed-off-by: Juergen Gross <jgross@suse.com>
    Reviewed-by: Dario Faggioli <dario.faggioli@citrix.com>
    Acked-by: Wei Liu <wei.liu2@citrix.com>

Index: xen-4.7.6-testing/tools/libxl/libxl.h
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/libxl.h
+++ xen-4.7.6-testing/tools/libxl/libxl.h
@@ -253,6 +253,12 @@
 #define LIBXL_HAVE_BUILD_ID 1
 
 /*
+ * LIBXL_HAVE_QEMU_MONITOR_COMMAND indiactes the availability of the
+ * libxl_qemu_monitor_command() function.
+ */
+#define LIBXL_HAVE_QEMU_MONITOR_COMMAND 1
+
+/*
  * libxl ABI compatibility
  *
  * The only guarantee which libxl makes regarding ABI compatibility
@@ -2067,6 +2073,14 @@ void libxl_psr_cat_info_list_free(libxl_
 int libxl_fd_set_cloexec(libxl_ctx *ctx, int fd, int cloexec);
 int libxl_fd_set_nonblock(libxl_ctx *ctx, int fd, int nonblock);
 
+/*
+ * Issue a qmp monitor command to the device model of the specified domain.
+ * The function returns the output of the command in a new allocated buffer
+ * via output.
+ */
+int libxl_qemu_monitor_command(libxl_ctx *ctx, uint32_t domid,
+                               const char *command_line, char **output);
+
 #include <libxl_event.h>
 
 #endif /* LIBXL_H */
Index: xen-4.7.6-testing/tools/libxl/libxl_colo_qdisk.c
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/libxl_colo_qdisk.c
+++ xen-4.7.6-testing/tools/libxl/libxl_colo_qdisk.c
@@ -173,7 +173,7 @@ static void colo_qdisk_save_preresume(li
                     "file.driver=nbd,file.host=%s,file.port=%d,"
                     "file.export=%s,node-name=%s,if=none",
                     host, port, export_name, node);
-    ret = libxl__qmp_hmp(gc, domid, cmd);
+    ret = libxl__qmp_hmp(gc, domid, cmd, NULL);
     if (ret)
         rc = ERROR_FAIL;
 
Index: xen-4.7.6-testing/tools/libxl/libxl_internal.h
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/libxl_internal.h
+++ xen-4.7.6-testing/tools/libxl/libxl_internal.h
@@ -1818,7 +1818,8 @@ _hidden int libxl__qmp_x_blockdev_change
                                          const char *parant,
                                          const char *child, const char *node);
 /* run a hmp command in qmp mode */
-_hidden int libxl__qmp_hmp(libxl__gc *gc, int domid, const char *command_line);
+_hidden int libxl__qmp_hmp(libxl__gc *gc, int domid, const char *command_line,
+                           char **out);
 /* close and free the QMP handler */
 _hidden void libxl__qmp_close(libxl__qmp_handler *qmp);
 /* remove the socket file, if the file has already been removed,
Index: xen-4.7.6-testing/tools/libxl/libxl_qmp.c
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/libxl_qmp.c
+++ xen-4.7.6-testing/tools/libxl/libxl_qmp.c
@@ -1067,14 +1067,54 @@ int libxl__qmp_x_blockdev_change(libxl__
     return qmp_run_command(gc, domid, "x-blockdev-change", args, NULL, NULL);
 }
 
-int libxl__qmp_hmp(libxl__gc *gc, int domid, const char *command_line)
+static int hmp_callback(libxl__qmp_handler *qmp,
+                        const libxl__json_object *response,
+                        void *opaque)
+{
+    char **output = opaque;
+    GC_INIT(qmp->ctx);
+    int rc;
+
+    rc = 0;
+    if (!output)
+        goto out;
+
+    *output = NULL;
+
+    if (libxl__json_object_is_string(response)) {
+        *output = libxl__strdup(NOGC, libxl__json_object_get_string(response));
+        goto out;
+    }
+
+    LOG(ERROR, "Response has unexpected format");
+    rc = ERROR_FAIL;
+
+out:
+    GC_FREE;
+    return rc;
+}
+
+int libxl__qmp_hmp(libxl__gc *gc, int domid, const char *command_line,
+                   char **output)
 {
     libxl__json_object *args = NULL;
 
     qmp_parameters_add_string(gc, &args, "command-line", command_line);
 
     return qmp_run_command(gc, domid, "human-monitor-command", args,
-                           NULL, NULL);
+                           hmp_callback, output);
+}
+
+int libxl_qemu_monitor_command(libxl_ctx *ctx, uint32_t domid,
+                               const char *command_line, char **output)
+{
+    GC_INIT(ctx);
+    int rc;
+
+    rc = libxl__qmp_hmp(gc, domid, command_line, output);
+
+    GC_FREE;
+    return rc;
 }
 
 int libxl__qmp_initializations(libxl__gc *gc, uint32_t domid,
Index: xen-4.7.6-testing/tools/libxl/xl.h
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/xl.h
+++ xen-4.7.6-testing/tools/libxl/xl.h
@@ -133,6 +133,7 @@ int main_psr_cmt_show(int argc, char **a
 int main_psr_cat_cbm_set(int argc, char **argv);
 int main_psr_cat_show(int argc, char **argv);
 #endif
+int main_qemu_monitor_command(int argc, char **argv);
 
 void help(const char *command);
 
Index: xen-4.7.6-testing/tools/libxl/xl_cmdimpl.c
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/xl_cmdimpl.c
+++ xen-4.7.6-testing/tools/libxl/xl_cmdimpl.c
@@ -9401,6 +9401,35 @@ int main_psr_hwinfo(int argc, char **arg
 
 #endif
 
+int main_qemu_monitor_command(int argc, char **argv)
+{
+    int opt;
+    uint32_t domid;
+    char *cmd;
+    char *output;
+    int ret;
+
+    SWITCH_FOREACH_OPT(opt, "", NULL, "qemu-monitor-command", 2) {
+        /* No options */
+    }
+
+    domid = find_domain(argv[optind]);
+    cmd = argv[optind + 1];
+
+    if (argc - optind > 2) {
+        fprintf(stderr, "Invalid arguments.\n");
+        return EXIT_FAILURE;
+    }
+
+    ret = libxl_qemu_monitor_command(ctx, domid, cmd, &output);
+    if (!ret && output) {
+        printf("%s\n", output);
+        free(output);
+    }
+
+    return ret ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
 /*
  * Local variables:
  * mode: C
Index: xen-4.7.6-testing/tools/libxl/xl_cmdtable.c
===================================================================
--- xen-4.7.6-testing.orig/tools/libxl/xl_cmdtable.c
+++ xen-4.7.6-testing/tools/libxl/xl_cmdtable.c
@@ -583,6 +583,11 @@ struct cmd_spec cmd_table[] = {
       "List information about all USB controllers and devices for a domain",
       "<Domain>",
     },
+    { "qemu-monitor-command",
+      &main_qemu_monitor_command, 0, 1,
+      "Issue a qemu monitor command to the device model of a domain",
+      "<Domain> <Command>",
+    },
 };
 
 int cmdtable_len = sizeof(cmd_table)/sizeof(struct cmd_spec);
Index: xen-4.7.6-testing/docs/man/xl.pod.1
===================================================================
--- xen-4.7.6-testing.orig/docs/man/xl.pod.1
+++ xen-4.7.6-testing/docs/man/xl.pod.1
@@ -1512,6 +1512,42 @@ List pass-through usb devices for a doma
 
 =back
 
+=head1 DEVICE-MODEL CONTROL
+
+=over 4
+
+=item B<qemu-monitor-command> I<domain-id> I<command>
+
+Issue a monitor command to the device model of the domain specified by
+I<domain-id>. I<command> can be any valid command qemu understands. This
+can be e.g. used to add non-standard devices or devices with non-standard
+parameters to a domain. The output of the command is printed to stdout.
+
+B<Warning:> This qemu monitor access is provided for convenience when
+debugging, troubleshooting, and experimenting.  Its use is not
+supported by the Xen Project.
+
+Specifically, not all information printed by the qemu monitor will
+necessarily be accurate or complete, because in a Xen system qemu
+does not have a complete view of the guest.
+
+Furthermore, modifying the guest's setup via the qemu monitor may
+conflict with the Xen toolstack's assumptions.  Resulting problems
+may include, but are not limited to: guest crashes; toolstack error
+messages; inability to migrate the guest; and security
+vulnerabilities which are not covered by the Xen Project security
+response policy.
+
+B<EXAMPLE>
+
+Obtain information of USB devices connected as such via the device model
+(only!) to a domain:
+
+ xl qemu-monitor-command vm1 'info usb'
+  Device 0.2, Port 5, Speed 480 Mb/s, Product Mass Storage
+
+=back
+
 =head1 TMEM
 
 =over 4
